## org.jfree.chart.urls
Class CustomPieURLGenerator

    java.lang.Object
      org.jfree.chart.urls.CustomPieURLGenerator

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, PieURLGenerator, org.jfree.util.PublicCloneable

    public class CustomPieURLGenerator

extends java.lang.Object
implements PieURLGenerator, java.lang.Cloneable, org.jfree.util.PublicCloneable, java.io.Serializable

A custom URL generator for pie charts.

See Also:
  Serialized Form

Constructor Summary
`CustomPieURLGenerator()` Creates a new `CustomPieURLGenerator` instance, initially empty.

Method Summary
`void` `addURLs(java.util.Map urlMap)` Adds a map containing `(key, URL)` mappings where each `key` is an instance of `Comparable` (corresponding to the key for an item in a pie dataset) and each `URL` is a `String` representing a URL fragment.
`java.lang.Object` `clone()` Returns a clone of the generator.
`boolean` `equals(java.lang.Object o)` Tests if this object is equal to another.
`java.lang.String` `generateURL(PieDataset dataset, java.lang.Comparable key, int pieIndex)` Generates a URL fragment.
`int` `getListCount()` Returns the number of URL maps stored by the renderer.
`java.lang.String` `getURL(java.lang.Comparable key, int mapIndex)` Returns the URL for a section in the specified map.
`int` `getURLCount(int list)` Returns the number of URLs in a given map (specified by its position in the map list).

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CustomPieURLGenerator

    public CustomPieURLGenerator()

  Creates a new `CustomPieURLGenerator` instance, initially empty. Call `addURLs(Map)` to specify the URL fragments to be used.

Method Detail

### generateURL

    public java.lang.String generateURL(PieDataset dataset,
                                        java.lang.Comparable key,
                                        int pieIndex)

  Generates a URL fragment.

  Specified by:
    `generateURL` in interface `PieURLGenerator`
  Parameters:
    `dataset` - the dataset (ignored).
    `key` - the item key.
    `pieIndex` - the pie index.
  Returns:
    A string containing the generated URL.
  See Also:
    `getURL(Comparable, int)`

### getListCount

    public int getListCount()

  Returns the number of URL maps stored by the renderer.

  Returns:
    The list count.
  See Also:
    `addURLs(Map)`

### getURLCount

    public int getURLCount(int list)

  Returns the number of URLs in a given map (specified by its position in the map list).

  Parameters:
    `list` - the list index (zero based).
  Returns:
    The URL count.
  See Also:
    `getListCount()`

### getURL

    public java.lang.String getURL(java.lang.Comparable key,
                                   int mapIndex)

  Returns the URL for a section in the specified map.

  Parameters:
    `key` - the key.
    `mapIndex` - the map index.
  Returns:
    The URL.

### addURLs

    public void addURLs(java.util.Map urlMap)

  Adds a map containing `(key, URL)` mappings where each `key` is an instance of `Comparable` (corresponding to the key for an item in a pie dataset) and each `URL` is a `String` representing a URL fragment.
  The map is appended to an internal list...you can add multiple maps if you are working with, say, a `MultiplePiePlot`.

  Parameters:
    `urlMap` - the URLs (`null` permitted).

### equals

    public boolean equals(java.lang.Object o)

  Tests if this object is equal to another.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `o` - the other object.
  Returns:
    A boolean.

### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

  Returns a clone of the generator.

  Specified by:
    `clone` in interface `org.jfree.util.PublicCloneable`
  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    A clone.
  Throws:
    `java.lang.CloneNotSupportedException` - if cloning is not supported.